# Environment
* PYNQ-Z1 (v2.4) (Release 2019_02_21)
* PYNQ Linux, based on Ubuntu 18.04
* Python 3.6.5

# Requirements
* Hardware solver (Latest ver. `190826_solver`) generated [here](https://www.togawa.cs.waseda.ac.jp/gitlab/adc2019/kawamura-solver/tree/master/hardware_design)
* Python module `MySolverModule` generated [here](https://www.togawa.cs.waseda.ac.jp/gitlab/adc2019/kawamura-solver/tree/master/solver_python)

# Usage

```
sudo python3 main.py -p input-Q-file(.txt) [-s seed-value] [-o output-A-file(.txt)]
```

* When running the script, 3 LEDs (LD0-LD2) are turned on & off as follows:

|(LD2, LD1, LD0)|state|
|:---:|:---|
|(0, 0, 0)|overlay loaded|
|(0, 0, 1)|start|
|(0, 1, 1)|1st routing completed|
|(0, 1, 0)|1st routing failed|
|(1, 1, 1)|2nd routing completed|
|(1, 0, 0)|2nd routing failed|

# Results
* 19.08.26: sample_Q.txt

|seed value|cost|final state|solution|real time|
|:---:|:---:|:---:|:---:|:---:|
|0|66  |(1, 1, 1)|15X11|51[sec.]|
|1|66  |(1, 1, 1)|15X11|51[sec.]|
|2|54.5|(1, 1, 1)| 7X12|18[sec.]|
|3|54.5|(1, 1, 1)| 8X10|15[sec.]|
|4|54.5|(1, 1, 1)| 8X11|14[sec.]|
|5|54.5|(1, 1, 1)| 9X10|12[sec.]|
|6|54.5|(1, 1, 1)| 9X11|15[sec.]|
|7|56  |(0, 1, 0)| N/A |14[sec.]|
|8|55  |(1, 0, 0)| N/A |37[sec.]|
|9|54.5|(1, 1, 1)| 8X12|15[sec.]|
